
#include <stdio.h>
int  chan, onoff, zeit, ton, vol, 
  chanwahl, i, j, bit = 1, p, n, marke = 0;
char ja;
static char leitern[13][3] =
{
  "c", "c#", "d", "d#", "e", "f", "f#", "g", "g#", "a", "a#", "h"};
static int mask[12] =
{
  1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048};
struct akko
  {
    int num;
    char name[20];

    int frq;
  };
static struct akko tonl[] =
{
{ 2741 ,  " c_dur" ,0 },
{ 1387 ,  " cis_dur" ,0 },
{ 2774 ,  " d_dur" ,0 },
{ 1453 ,  " dis_dur" ,0 },
{ 2906 ,  " e_dur" ,0 },
{ 1717 ,  " f_dur" ,0 },
{ 3434 ,  " fis_dur" ,0 },
{ 2773 ,  " g_dur" ,0 },
{ 1451 ,  " gis_dur" ,0 },
{ 2902 ,  " a_dur" ,0 },
{ 1709 ,  " ais_dur" ,0 },
{ 3418 ,  " h_dur" ,0 },
{ 2477 ,  " c_moll" , 0},
{  859 ,  " cis_moll" , 0},
{ 1718 ,  " d_moll" , 0},
{ 3436 ,  " dis_moll" , 0},
{ 2777 ,  " e_moll" , 0},
{ 1459 ,  " f_moll" , 0},
{ 2918 ,  " fis_moll" , 0},
{ 1741 ,  " g_moll" , 0},
{ 3482 ,  " gis_moll" , 0},
{ 2869 ,  " a_moll" , 0},
{ 1643 ,  " ais_moll" , 0},
{ 3286 ,  " h_moll" , 0},
  {0, "nix", 0}};
/*===========U.-Progr Ausgabe der nicht eliminierten Tonarten================*/
ausgabe()
	    {
	      for (j = 0; j < 24; j++)
		if ((tonl[j].frq == 0) || (tonl[j].frq == marke ))
		  printf ("%s ", tonl[j].name);
	      printf ("\n");
	      for (j = 0; j < 24; j++) /* if(tonl[j].frq < marke) */
		tonl[j].frq = 0;
	      marke = 0;
	    }
/*==============================Hauptprogramm============================*/
int
main (cpar, vpar)
     int cpar;
     char *vpar[];
{
/*.................Eroeffnung........................................... */
  if (cpar < 2)
    goto schluss;
  chanwahl = 0;
  fprintf (stderr, "%s\n", vpar[1]);
for(i=0;i<24;i++) tonl[i].frq = 0;
/*.........................Kanalwahl.................................... */
  for (n = 2; n < cpar; n++)
    {
      i = atoi (vpar[n]);
      fprintf (stderr, "%d\n", i);
      if ((i < 0) || (i > 15))
	goto schluss;
      bit = 1;
      bit = bit << i;
      chanwahl = chanwahl | bit;
    }
  /*...................Einlesen und auswaehlen.......................... */
  while (scanf ("%d%d%d%d%d", &chan, &onoff, &zeit, &ton, &vol) == 5)
    {
      if (!onoff)
	continue;
      marke++;
      p = 1;
      p = p << chan;
      if ((p & chanwahl) != 0)
	{
	  ton = ton % 12;
	  for (i = 0; i < 24; i++)
	    if ((tonl[i].num & mask[ton]) == 0)  if(tonl[i].frq==0)
	      tonl[i].frq = marke;
	  i = 0;
	  for (j = 0; j < 24; j++)
	    i = i || (tonl[j].frq == 0);      /* printf("%33d  %d\n",i,marke);*/
	  if (!i ) ausgabe();
	  printf ("%55d %d %d %d %d, %s\n", chan, onoff, zeit, ton, vol,leitern[ton]);
	}
    }ausgabe();
  goto ok;
schluss:puts ("Abbruch, Fehleingabe");
ok:puts ("ende von tonarten-prog.");
}
